



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C++ Primer 5th 第1章 开始</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C++ Primer 5th 第1章 开始</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-29 17:33:34 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>*****代码在Ubuntu g++ 5.31 / clang++ 3.8(C++11)下编写调试*****</strong></p>
<p>每个C++程序必须有一个main( )函数，main( )函数的返回值也必须是int类型，操作系统通过调用main( )函数来运行C++程序。</p>
<p>1.函数格式</p>
<p>函数：C++的函数是一个能够完成一个功能的模块或者说是<strong>一段命名了的代码块</strong>。</p>
<p>完整函数的组成：</p>
<p>①返回类型：不一定有返回值，但一定有返回类型，无返回值时，使用void来说明类型</p>
<p>②函数名：根据名字标识完成特定功能的模块，必须存在 //lambda匿名函数除外</p>
<p>③形参列表：可能没有参数传入，但是一对括号必须存在</p>
<p>④函数体：一个完整的函数必须有函数体，里面包含要实现的功能。</p>
<p>下面为一个完整函数的例子：</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
    return ;<br />
}</pre>
</div>
<p><strong>如果main( )函数的返回类型是非int的,编译时将会报错,错误如下:</strong></p>
<div>
<pre class="prettyprint linenums"> error: &lsquo;::main&rsquo; must return &lsquo;int&rsquo;<br />
 double main(int argc,char *argv[])</pre>
</div>
<p><strong>若函数的返回值与函数事先定义的返回类型不一致时，会将返回值隐式转换到事先定义的类型。例子如下:</strong></p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;

using namespace std;

int main(int argc,char *argv[])<br />
{

    return 16.5;<br />
}</pre>
</div>
<p>以上返回值是一个double类型的16.5,使用clang++编译时会得到提示:</p>
<div>
<pre class="prettyprint linenums">first.cpp::: warning: implicit conversion from 'double' to 'int' changes value from 16.5 to<br />
      [-Wliteral-conversion]<br />
        return 16.5;<br />
        ~~~~~~ ^~~~<br />
 warning generated.</pre>
</div>
<p>而g++编译时则无任何提示,编译运行后查看返回值,可以看到返回的是int的16</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/733392/201606/733392-20160627102042281-1618189168.png" /></p>
<p>另外，在C/C++标准中，是允许main( )没有return语句的，如果没有return语句，则在程序的末尾隐式插入一条return 0;语句。</p>
<p>在UNIX/Linux系统中，main( )函数的返回值可以被用来判断程序的执行情况，下面是几个常见的返回值</p>
<table>
<thead>
<tr>
<th>xit Code Number</th>
<th>Meaning</th>
<th>Example</th>
<th>Comments</th>
</tr>
</thead>
<tbody>
<tr>
<td><tt>1</tt></td>
<td>Catchall for general errors</td>
<td>let "var1 = 1/0"</td>
<td>Miscellaneous errors, such as&nbsp;"divide by zero"&nbsp;and other impermissible operations</td>
</tr>
<tr>
<td><tt>2</tt></td>
<td>Misuse of shell builtins (according to Bash documentation)</td>
<td>empty_function() {}</td>
<td><a href="http://www.tldp.org/LDP/abs/html/debugging.html#MISSINGKEYWORD" rel="external nofollow noreferrer">Missing keyword</a>&nbsp;or command, or permission problem (and&nbsp;<a href="http://www.tldp.org/LDP/abs/html/filearchiv.html#DIFFERR2" rel="external nofollow noreferrer"><em>diff</em>&nbsp;return code on a failed binary file comparison</a>).</td>
</tr>
<tr>
<td><tt>126</tt></td>
<td>Command invoked cannot execute</td>
<td>/dev/null</td>
<td>Permission problem or command is not an executable</td>
</tr>
<tr>
<td><tt>127</tt></td>
<td>"command not found"</td>
<td>illegal_command</td>
<td>Possible problem with&nbsp;<tt>$PATH</tt>&nbsp;or a typo</td>
</tr>
<tr>
<td><tt>128</tt></td>
<td>Invalid argument to&nbsp;<a href="http://www.tldp.org/LDP/abs/html/exit-status.html#EXITCOMMANDREF" rel="external nofollow noreferrer">exit</a></td>
<td>exit 3.14159</td>
<td><strong>exit</strong>&nbsp;takes only integer args in the range&nbsp;0 - 255&nbsp;(see first footnote)</td>
</tr>
<tr>
<td><tt>128+n</tt></td>
<td>Fatal error signal&nbsp;"n"</td>
<td><em>kill -9</em>&nbsp;<tt>$PPID</tt>&nbsp;of script</td>
<td><tt><strong>$?</strong></tt>&nbsp;returns&nbsp;137&nbsp;(128 + 9)</td>
</tr>
<tr>
<td><tt>130</tt></td>
<td>Script terminated by Control-C</td>
<td><em>Ctl-C</em></td>
<td>Control-C is fatal error signal&nbsp;2, (130 = 128 + 2, see above)</td>
</tr>
<tr>
<td><tt>255*</tt></td>
<td>Exit status out of range</td>
<td>exit&nbsp;-1</td>
<td><strong>exit</strong>&nbsp;takes only integer args in the range&nbsp;0 - 255</td>
</tr>
</tbody>
</table>
<p>2.源文件、代码、编译，以及执行与程序返回值</p>
<p>源文件就是包含代码的那个文件，代码即所写的程序文字，编译是将代码翻译成二进制的过程，编译后会生成新的可执行文件。</p>
<p>在linux中执行一个程序（非脚本执行文件）的方式就是直接执行，无需bash来加载，可以使用绝对路径，也可以使用当前路径。绝对路径就是从根目录开始，一直写到可执行文件的文件名，然后回车执行。linux默认不搜索当前路径，因此使用当前路径时，要显式指出当前的路径，指出当前路径的方法是"<strong>./</strong>"（一个点和一个斜杠，不含引号），例如编译后的可执行文件名叫ex，在当前路径执行就是<strong>./</strong>ex。</p>
<p>在linux下编译时，命令如下：</p>
<div>
<pre class="prettyprint linenums"> g++ filename.cpp -o file_exec -std=c++11　　　　//使用g++编译<br />
 clang++ filename.cpp -o file_exec -std=c++11　　//或者使用clang++编译</pre>
</div>
<p>上面2个命令二者二选一，使用哪个取决于你安装了哪个编译器。</p>
<p>命令解释：</p>
<p>g++或者clang++是指定编译器，其后的filename.cpp是你所要编译的源文件，即代码所在文件，-o选项是指定编译后的程序名(即output)，-std=c++11选项是使用c++11标准，当然这里只是一个简单的程序，并没有用到c++11特性，该选项可选可不选。</p>
<blockquote><p>如果你忘记用-o name选项告诉编译器可执行程序的名字,编译器就会把程序放在一个名为a.out的文件里(a.out的含义是assembler output,即汇编输出)。如果你确信编译了一个程序但又找不到它,别忘了看看有没有a.out文件!在UNIX的早期历史中,想在系统上玩游戏的人通常把游戏作为a.out来运行,以避免被系统管理员捉到,因此一些UNIX系统每晚会定期地删除所有名为a.out的文件。 &nbsp;　　&mdash;&mdash;来自Linux程序设计:第4版/(英)马修(Matthew, N.),(英)斯通斯(Stones,R.)</p></blockquote>
<p>程序的返回值使用echo $?来查看，$?是linux默认的变量，专门用于查询上一程序的返回值。</p>
<p>编译程序可以使用GNU的g++或者clang++来编译，语法是g++ file.name -o file或者clang++-3.5 file.name -o file，其中-o选项是指定编译后的文件名</p>
<p>C++源文件的后缀名有: .cc 、.cpp 、.cxx 、.cp 、.C（大写的C）</p>
<p>3.标准输入输出对象，输入输出流</p>
<p>C++一共有四个标准输入输出对象：cin、cout、cerr、clog，其中cin是用来从流读出数据，cout用来向流写入数据。</p>
<p>输入和输出并不是C++语言中的正式组成成分。C和C++本身都没有为输入和输出提供专门的语句结构。输入输出不是由C++本身定义的，而是在编译系统提供的I/O库中定义的，该库是iostream库，这个库是g++在编译时自动链接的，gcc也能编译c++文件，但默认只能链接c语言的库，而无法自动链接c++库，g++可以自动链接c++库。</p>
<p><strong>造成这个问题的原因是：</strong></p>
<p><strong>这是在那个计算机运行还很慢，CPU周期代价还很昂贵的时期遗留下来的历史问题。</strong></p>
<p>C++标准输入输出定义了4个IO，分别为：CIN（标准输入）、COUT（标准输出）、CERR（标准错误）、CLOG，前三个在linux下是自动在当前程序下被打开的。也即任何在linux下的程序，操作系统会默认为程序打开3个文件：标准输入\输出\错误 &nbsp; // Linux下一切皆文件 ：)</p>
<p>四个IO是4个基本对象，是istream和ostream类型的对象。类似于int类型的变量。</p>
<p>之所以定义流，是为了跨平台，统一接口，方便开发，屏蔽硬件细节，所以抽象了这一概念。</p>
<p>标准输入输出存在缓冲和非缓冲的概念，标准错误是非缓冲的，一旦出现错误，就立马输出错误。</p>
<p>缓冲的目的是防止每次读写一次文件，就要CPU中断或者文件系统驱动一次硬件，使用缓冲，可以将多次的改动一次性写入到文件，减少中断和硬件驱动，提高效率。</p>
<p>关于endl操纵符：它不仅结束当前行，更重要的是能刷新缓冲！有的时候明明打印了，但看不到输出，很可能是输出被缓存在缓冲里面，这时可以用endl来刷新缓冲，以写到设备中，比如显示器。通常你要是在程序使用了cout，建议配对使用endl。</p>
<p>4.标准库、命名空间、连续输入输出</p>
<p>对于使用了标准库的程序，必须包含标准库的头文件，包含标准库的头文件是使用 #include 指令来完成的，&nbsp;#incude 指令可以放在程序的任何地方，但是这个任何地方并不是指可以放在程序函数的内部，而是函数或者类的外面，通常&nbsp;#include 指令是放在源码开头处的。另外，&nbsp;#include 指令不允许换行，该指令必须和其后面引入的头文件在同一行上。</p>
<p>C++头文件的后缀名有: .h 、.H 、.hxx 、.hpp 以及不使用后缀</p>
<p>输出运算符&lt;&lt;，&lt;&lt;是一个运算符！就如同 1+2中的&ldquo;+&rdquo;号一样，是用来计算的，只不过其&ldquo;计算&rdquo;与数学运算的&ldquo;直觉感官&rdquo;不太一样，此运算符作用是将符号右侧的值写入到左侧ostream对象中去，运算的返回来的结果还是左侧的ostream对象，所以可以连写，形成链式表达式。又因为ostream对象是不能复制的，这就是为什么很多流运算符重载时要返回引用的原因。</p>
<p>例如: cout&lt;&lt;"first"&lt;&lt;"second"; 因为他是个运算符，所以可以像(a+b)+c一样带上具有优先级的括号，例如: （cout&lt;&lt;"first"）&lt;&lt;"second";</p>
<p>考虑一下：std::cout&lt;&lt;"first"&lt;&lt;(std::out&lt;&lt;"second");这条语句是否正确呢？如果正确，为什么正确？如果错误，为什么错误？</p>
<p><strong>重点理解输出运算符&lt;&lt;的本质，这在运算符重载时会用到，若未理解，很容易困惑！</strong></p>
<p>输入运算符与输出运算符类似，其左侧是一个istream的流对象，右侧是一个用来存储istream流的对象。</p>
<p>对命名空间的理解：由于程序越来越大，一个程序由不同的人负责不同的部分，同一个项目里面不同的开发人员可能会给变量起相同的名字，这样就会导致冲突，程序异常。为了避免这个问题，引入&ldquo;命名空间&rdquo;这个概念，每个部分的开发者为自己的代码指定名字空间（比如依据开发者的姓名），这样在遇到有冲突的变量名时，指定变量具体所属的文件，就避免了冲突；</p>
<p>关于缓冲的知识，可以在操作系统的IO设备管理中学习，或者linux程序设计一类，具体可以参考相应的书籍。</p>
<p>5.如何注释</p>
<p>C++有2种注释风格，一种单行双斜杠注释，如 //这是一个注释</p>
<p>另外一直是多行界定符注释，如/*注释内容*/，这种注释不能相互嵌套，比如注释/* 第一层注释 &nbsp;/* 第二层注释 &nbsp; */ 第一层注释 &nbsp; */，这种情况下从第一个界定符到第三个界定符视为注释，最后一个*/则视为不能识别的代码。</p>
<div>6.程序的执行顺序与循环</div>
<div>计算机程序默认是从上到下，一步一步顺序执行的，也可以在某个地方一直循环执行，然后再往下继续执行。</div>
<div>While循环的格式为：</div>
<div>
<div>
<pre class="prettyprint linenums">while (condition)　　//注意括号<br />
statement;
</pre>
</div>
<p>关于C++语句：C++中语句有2种，一种是以分号 &ldquo;;&rdquo; 结尾的，另一种是一对大括号包围的 &ldquo; { } &rdquo;的复合语句，大括号里面是是以分号 &ldquo;;&rdquo; 结尾的一条或者多条语句的复合，在任何要求使用语句的地方，都能用大括号的符合语句代替。</p>
<div>7.while、for循环和连续读取</div>
<div>while循环可以使用这种格式：while (std::cin &gt;&gt; value)来不断的连续读取。for循环类似while循环。</div>
<div>
<div>
<p>注意以下代码循环部分：</p>
</div>
<div>
<div>
<pre class="prettyprint linenums">while (a&gt;b)<br />
　　if(m&gt;n)<br />
　　　　....;<br />
　　else<br />
　　　　....;
</pre>
</div>
<p>上面这段代码while循环后跟了if,else，并且while循环体没有加花括号，那么while循环体是到哪为止呢，我之前不理解，一直以为到第一个分号截止，直到看到这段代码，才知道if...else...这段代码是看作一个整体，因此上面的都是while循环。</p>
</div>
</div>
</div>
<div>8.使用if对程序二选一的分支进行选择</div>
<div>有的时候程序需要做出二选一的判断，那么使用if即可做出判断。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>9.C++的缩进与格式</div>
<div>C++的左花括号有换行和不换行的风格，建议换行，整齐美观，便于阅读，以前的屏幕小，需要同时看更多的代码，少换一行就能多看一行，但是现在屏幕大，没有必要再这么做了，代码是给人看的，不是给机器看的。</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>10.类思想与类对象加法</div>
<div>类同分门别类的意思相近，是一种类型，一种类型就有相应的存储大小和操作方式（即能参与的运算），如int类型。</div>
<div>通俗解释是你是从事什么行业将会决定你会在哪里活动（存储），你能做些什么（操作）。</div>
<div>
<div>类似C里面的结构，类和结构很像，是自定义的一种类型，但是差别很大。C语言里面的ADT与类很像，但是也有很大的差别。第一，在非面向对象环境（如C与Fortran）中只能使用ADT，处理多个数据实例的时候，需要手动设置，要为ADT添加一些用来创建和删除实例的服务操作，还需要重新设计ADT的其他服务操作以能够支持多个实例。 类就不必了。</div>
<div>&nbsp;</div>
<div>对类的初步理解是类是为C++定义的一种外置数据类型，一种数据类型确定的时候也就相应的确定了类型的一个属性集和一个操作集。比如，int类型的属性是它表示一个整数值，因此它拥有整数的属性。它允许的算术操作是改变一个int数的符号、两个int数相加、两个int数相减、两个int数相乘、两个int数相除，以及一个int数对另一个取模。</div>
<div>在声明一个变量为int型时，您的意思是这些操作并且只有这些操作可以对其起作用。【这段话来自C Primer Plus】</div>
</div>
<div>11.文件重定向</div>
<div>
<pre class="prettyprint linenums">输入重定向使程序能够使用文件代替键盘作为输入，输出重定向则使程序能够使用文件代替屏幕作为输出。</pre>
</div>
<p>例如：</p>
<div>
<pre class="prettyprint linenums"> ls -l &gt; lsoutput.txt</pre>
</div>
<p>这条命令把ls命令的输出保存到文件lsoutput.txt中。重定向所包含的内容可比这个简单的例子所显示的要多得多。目前只需知道文件描述符0代表一个程序的标准输入,</p>
<p>文件描述符1代表标准输出,而文件描述符2代表标准错误输出。你可以单独地重定向其中任何一个，例如重定向错误输出：</p>
<div>
<pre class="prettyprint linenums"> find / -name SHORT &gt; findoutput.txt　　//普通用户从/目录下查找时，会遇到权限问题，关于权限错误的输出可以被重定向到findoutput.txt中</pre>
</div>
<p>事实上,你还可以重定向其他文件描述符,但对标准文件描述符0、1、2以外的文件描述符进行重定向的情况很少见。上面的例子通过&gt;操作符把标准错误重定向到一个文件。在默认情况下,如果该文件已经存在,它的内容将被覆盖。</p>
<p>你也可以用&gt;&gt;操作符将输出内容<strong>追加</strong>到一个文件中。</p>
<p>练习 1.1：查阅你使用的编译器文档，确定它所使用的文件命名约定。编译并运行第2页的main程序。</p>
<p>我使用的编译器是GCC 5.3.1,官方文档可以在gcc.gnu.org/onlinedocs中查阅。</p>
<p>练习 1.2：改写程序，让它返回-1。返回值-1 通常被当作程序错误的标识。重新编译并运行你的程序，观察你的系统如何处理main 返回的错误标识。</p>
<p>解答：在Debian 8.2下编译成功，运行无报错（空白输出），使用 echo $? 查看程序的返回状态，得到的结果是&ldquo;255&rdquo;，main函数中的return, 只能使用0~255之间的值. -1 的unsigned值就是255.</p>
<p>练习 1.3：编写程序，在标准输出上打印Hello, World。</p>
<p>解答：</p>
<div>
<p>#include &lt;iostream&gt;</p>
<pre class="prettyprint linenums">int main()<br />
{<br />
	std::cout &lt;&lt; "Hello,World." &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
<p>练习1.4：我们的程序使用加法运算符+来将两个数相加。编写程序使用乘法运算符*，来打印两个数的积。</p>
<p>解答：</p>
<div>
<p>#include &lt;iostream&gt;</p>
<pre class="prettyprint linenums">int main()<br />
{<br />
	int v1 = 0, v2 = 0;<br />
	std::cout &lt;&lt; "input two numbers:" &lt;&lt; std::endl;<br />
	std::cin &gt;&gt; v1 &gt;&gt; v2;<br />
	std::cout &lt;&lt; "the product of " &lt;&lt; v1 &lt;&lt; " and " &lt;&lt; v2 &lt;&lt; " is " &lt;&lt; v1*v2 &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
<p>练习 1.5：我们将所有输出操作放在一条很长的语句中。重写程序，将每个运算对象的打印操作放在一条独立的语句中。</p>
<p>解答：</p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
int main()<br />
{<br />
	int v1 = 0, v2 = 0;<br />
	std::cout &lt;&lt; "input two numbers:" &lt;&lt; std::endl;<br />
	std::cin &gt;&gt; v1 &gt;&gt; v2;<br />
	std::cout &lt;&lt; "the product of ";<br />
	std::cout &lt;&lt; v1;<br />
	std::cout &lt;&lt; " and ";<br />
	std::cout &lt;&lt; v2;<br />
	std::cout &lt;&lt; " is ";<br />
	std::cout &lt;&lt; v1*v2;<br />
	std::cout &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
<p>练习 1.6：解释下面程序片段是否合法。</p>
<div>
<pre class="prettyprint linenums">std::cout &lt;&lt; "The sum of " &lt;&lt; v1;<br />
&lt;&lt; " and " &lt;&lt; v2;<br />
&lt;&lt; " is " &lt;&lt; v1 + v2 &lt;&lt; std::endl;</pre>
</div>
<p>如果程序是合法的，它输出什么？如果程序不合法，原因何在？应该如何修正？</p>
<p>解答：</p>
<div>
<pre class="prettyprint linenums">std::cout &lt;&lt; "The sum of " &lt;&lt; v1;    //合法，假定v1=1，则输出The sum of 1
</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;&lt; " and " &lt;&lt; v2;	//不合法，因为输出运算符要求左侧是输出流对象，应修正为std::cout &lt;&lt; " and " &lt;&lt; v2;
</pre>
</div>
<div>
<pre class="prettyprint linenums">&lt;&lt; " is " &lt;&lt; v1 + v2 &lt;&lt; std::endl;    ////不合法，原因同第二个语句，应修正为 std::cout &lt;&lt; " is " &lt;&lt; v1 + v2 &lt;&lt; std::endl;</pre>
</div>
<p>练习1.7：编译一个包含 不正确的嵌套注释的程序，观察编译器返回的错误信息。</p>
<div>
<pre class="prettyprint linenums">int main()<br />
{<br />
	std::cout &lt;&lt; "test of comments!";	/*  /* test */  */<br />
	return 0;<br />
}</pre>
</div>
<div>
<pre class="prettyprint linenums">VS 2013报错：

1&gt;------ Build started: Project: return, Configuration: Debug Win32 ------<br />
1&gt;  return.cpp<br />
1&gt;c:\users\pluse\documents\visual studio 2013\projects\return\return\return.cpp(4): warning C4138: '*/' found outside of comment<br />
1&gt;c:\users\pluse\documents\visual studio 2013\projects\return\return\return.cpp(4): error C2059: syntax error : '/'<br />
========== Build: 0 succeeded, 1 failed, 0 up-to-date, 0 skipped ==========</pre>
</div>
<div>
<pre class="prettyprint linenums">Red Hat报错：

1.7.cpp: In function &lsquo;int main()&rsquo;:<br />
1.7.cpp:4: error: expected primary-expression before &lsquo;/&rsquo; token<br />
1.7.cpp:5: error: expected primary-expression before &lsquo;return&rsquo;<br />
1.7.cpp:5: error: expected &lsquo;;&rsquo; before &lsquo;return&rsquo;
</pre>
</div>
<p>　　</p>
<p>练习1.8：指出下列哪些输出语句是合法的（如果有的话）：</p>
<div>
<pre class="prettyprint linenums">std::cout &lt;&lt; "/*";<br />
std::cout &lt;&lt; "*/";<br />
std::cout &lt;&lt; /* "*/" */;<br />
std::cout &lt;&lt; /* "*/" /* "/*" */;
</pre>
</div>
<p>预测编译这些语句会产生什么样的结果，实际编译这些语句来验证你的答案（编写一个小程序，每次将上述一条语句作为其主体），改正每个编译错误。</p>
<p>解答：</p>
<p>双引号里面包含的内容是直接输出的，不做注释用，因此只有第3个错误。应该修改为：</p>
<div>
<pre class="prettyprint linenums">std::cout &lt;&lt; /* "*/" */ &ldquo;;</pre>
</div>
<p>　</p>
<div>练习 1.9：编写程序，使用while 循环将50 到100 的整数相加。</div>
<div>解答：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
int main()<br />
{<br />
	int val = 50, sum = 0;<br />
	while (val &lt;= 100)<br />
	{<br />
		sum += val;<br />
		val++;<br />
	}<br />
	std::cout &lt;&lt; "Sum of 50 to 100 inclusive is " &lt;&lt; sum &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
</div>
<div>练习 1.10：除了++运算符将运算对象的值增加1 之外，还有一个递减运算符实现将值减少1。编写程序，使用递减运算符在循环中按递减顺序打印出10 到0 之间的整数。</p>
<div>解答：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
int main()<br />
{<br />
	int val = 10;<br />
	while (val &gt;=0)<br />
	{<br />
		std::cout &lt;&lt; val&lt;&lt;" ";<br />
		val--;<br />
	}<br />
	std::cout &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
</div>
</div>
<div>&nbsp;</div>
<div>练习 1.11：编写程序，提示用户输入两个整数，打印出这两个整数所指定的范围内的所有整数。<br />解答：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;　　<br />//目前还未学习其他的循环和判定，因此仅使用while来实现<br />
int main()<br />
{<br />
	int a,b;<br />
	std::cout &lt;&lt; "input two numbers:";<br />
	std::cin &gt;&gt; a &gt;&gt; b;<br />
	while (a&lt;=b)<br />
	{<br />
		std::cout &lt;&lt; a &lt;&lt; " ";<br />
		a++;<br />
	}<br />
	while (a &gt; b)<br />
	{<br />
		std::cout &lt;&lt; b &lt;&lt; " ";<br />
		b++;<br />
	}<br />
	std::cout &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
</div>
<div>1.4.2 for 语句</div>
<div>for语句的形式需要注意</div>
<div>
<div>
<pre class="prettyprint linenums">for(INITIALIZATION;CONDITION;INCREMENT) //注意分号！<br />
statement;
</pre>
</div>
</div>
<div>练习 1.12：下面的for 循环完成了什么功能？sum 的终值是多少？</div>
<div>
<div>
<pre class="prettyprint linenums">int sum = 0;<br />
for (int i = -100; i &lt;= 100; ++i)<br />
sum += i;
</pre>
</div>
<p>解答：</p>
<p>for循环完成了-100到100的累加和，sum的终值是0。</p>
</div>
<div>&nbsp;</div>
<div>练习1.13：使用for 循环重做1.4.1 节中的所有练习（第13 页）。</div>
<div>解答：</div>
<div>[&middot;练习 1.9：使用for循环将50 到100 的整数相加。]</div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;

int main()<br />
{<br />
	int sum = 0;<br />
	for (int i = 50; i &lt;= 100; i++)<br />
		sum += i;<br />
	std::cout &lt;&lt; "Sum of 50 to 100 inclusive is " &lt;&lt; sum &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
<p>[练习 1.10：除了++运算符将运算对象的值增加1 之外，还有一个递减运算符实现将值减少1。编写程序，使用递减运算符在for循环中按递减顺序打印出10 到0 之间的整数。]</p>
</div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;

int main()<br />
{<br />
	for (int i = 10; i &gt;= 0; i--)<br />
		std::cout &lt;&lt; i &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
<p>[练习 1.11：编写程序，提示用户输入两个整数，使用for循环打印出这两个整数所指定的范围内的所有整数。]　</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;

int main()<br />
{<br />
	int a, b;<br />
	std::cout &lt;&lt; "Enter two numbers:" &lt;&lt; std::endl;<br />
	for ( std::cin &gt;&gt; a &gt;&gt; b; a &lt;= b; a++)<br />
		std::cout &lt;&lt; a &lt;&lt; "  ";<br />
	return 0;<br />
}
</pre>
</div>
<p>　　</p>
</div>
<div>练习 1.14：对比for 循环和while 循环，两种形式的优缺点各是什么？</div>
<div>解答：</div>
<div>个人看来只是2种不同形式的循环，没有太大差别，引用搜索出来的答案:</div>
<div>&ldquo;在for循环中，循环控制变量的初始化和修改都放在语句头部分，形式较简洁，且特别适用于循环次数已知的情况。在while循环中，循环控制变量的初始化一般放在while语句之前，循环控制变量的修改一般放在循环体中，形式上不如for语句简洁，但它比较适用于循环次数不易预知的情况（用某一条件控制循环）。两种形式各有优点，但它们在功能上是等价的，可以相互转换。&rdquo;</div>
<div>练习 1.15：编写程序，包含第16 页&ldquo;再探编译&rdquo;中讨论的常见错误。熟悉编译器生成的错误信息。</div>
<div>
<div>解答：</div>
<div>没找到是指哪个程序，略过。</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>练习 1.16：编写程序，从cin 读取一组数，输出其和。</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;　　//书上的程序并不能很好的工作，没有提供结束的方法<br />
int main()<br />
{<br />
	int sum = 0, value = 0;<br />
	std::cout &lt;&lt; "enter q to quit:";　　//输入字母q来退出，实际上，任何字母都能退出，这是因为value是一个int类型，输入的q属于char类型，<br />
	while (std::cin &gt;&gt; value)	　　//因此std::cin &gt;&gt; value会返回false从而结束循环<br />
		sum += value;<br />
	std::cout &lt;&lt; "Sum is: " &lt;&lt; sum &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
</div>
<div>
<pre class="prettyprint linenums"></pre>
<p>1.4.4 if语句</p></div>
<div>if语句形式：</div>
<div>
<div>
<pre class="prettyprint linenums">if(expression)　　　　//注意if后面的括号！！<br />
statement;
</pre>
</div>
</div>
<div>练习1.17：如果输入的所有值都是相等的，本节的程序会输出什么？如果没有重复值，输出又会是怎样的？</div>
<div>解答：</div>
<div>如果输入的所有值都是相等的，程序在结束时会输出输入的值连续出现了多少次。如果没有重复值，输出会输出之前的值连续出现了1次。</div>
<div>代码以及输出如下：</div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
int main()<br />
{<br />
	int curval, val;<br />
	if (std::cin &gt;&gt; curval)<br />
	{<br />
		int cnt = 1;<br />
		while (std::cin &gt;&gt; val)<br />
		{<br />
			if (curval == val)<br />
				cnt++;<br />
			else<br />
			{<br />
				std::cout &lt;&lt; curval &lt;&lt; " occurs " &lt;&lt; cnt &lt;&lt; " times " &lt;&lt; std::endl;<br />
				cnt = 1;<br />
				curval = val;<br />
			}<br />
		}<br />
		std::cout &lt;&lt; curval &lt;&lt; " occurs " &lt;&lt; cnt &lt;&lt; " times " &lt;&lt; std::endl;<br />
	}<br />
	return 0;<br />
}

output:<br />
$ ./if_cpp<br />
5<br />
5<br />
5<br />
1<br />
5 occurs 3 times<br />
2<br />
1 occurs 1 times<br />
3<br />
2 occurs 1 times<br />
4<br />
3 occurs 1 times<br />
5<br />
4 occurs 1 times<br />
6<br />
5 occurs 1 times<br />
[ctrl^D] 6 occurs 1 times</pre>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>练习1.18：编译并运行本节的程序，给它输入全都相等的值。再次运行程序，输入没有重复的值。</div>
<div>解答：</div>
<div>略</div>
<div>&nbsp;</div>
<div>练习1.19：修改你为1.4.1节练习1.11（第13页）所编写的程序（打印一个范围内的数），使其能处理用户输入的第一个数比第二个数小的情况。</div>
<div>解答：</div>
<div>1.11的答案已能实现。</div>
<div>代码如下：</div>
<div>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;　　<br />
//目前还未学习其他的循环和判定，因此仅使用while来实现

int main()<br />
{<br />
	int a,b;<br />
	std::cout &lt;&lt; "input two numbers:";<br />
	std::cin &gt;&gt; a &gt;&gt; b;<br />
	while (a&lt;=b)<br />
	{<br />
		std::cout &lt;&lt; a &lt;&lt; " ";<br />
		a++;<br />
	}<br />
	while (a &gt; b)<br />
	{<br />
		std::cout &lt;&lt; b &lt;&lt; " ";<br />
		b++;<br />
	}<br />
	std::cout &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
</div>
<div>&nbsp;</div>
<div>练习 1.20：在网站http://www.informit.com/title/0321714113 上，第1 章的代码目录中包含了头文件Sales_item.h。将它拷贝到你自己的工作目录中。用它编写一个程序，读取一组书籍销售记录，将每条记录打印到标准输出上。</div>
<div>解答：</div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include "Sales_item.h"      //使用root权限拷贝或者建立链接到/usr/include目录下，或者编译时使用 -I 选项指定该文件所在的目录

int main()<br />
{<br />
	Sales_item item;<br />
	while (std::cin &gt;&gt; item)<br />
	{<br />
		std::cout &lt;&lt; item &lt;&lt; std::endl;<br />
	}

	return 0;<br />
}

//编译时需指定 -std=c++11 选项</pre>
</div>
</div>
<div>&nbsp;</div>
<div>练习 1.21：编写程序，读取两个ISBN 相同的Sales_item 对象，输出它们的和。</div>
<div>解答：</div>
<div>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include "Sales_item.h"　　　　<br />
int main()<br />
{<br />
	Sales_item item1, item2;<br />
	std::cin &gt;&gt; item1 &gt;&gt; item2;<br />
　　　　 if (item1.isbn() == item2.isbn())<br />
	　　std::cout &lt;&lt; item1 + item2 &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
</div>
<div>
<div>&nbsp;</div>
<p>练习 1.22：编写程序，读取多个具有相同ISBN 的销售记录，输出所有记录的和。</p></div>
<div>解答：</div>
<div>
<div>
<pre class="prettyprint linenums">/*程序缺陷：不能很好的退出*/<br />
#include &lt;iostream&gt;<br />
#include "Sales_item.h"<br />
int main()<br />
{<br />
	Sales_item item1, item2;<br />
	std::cout &lt;&lt; "Enter transactions:" &lt;&lt; std::endl;<br />
	if (std::cin &gt;&gt; item1)<br />
	{<br />
		while (std::cin &gt;&gt; item2)<br />
		{<br />
			if (item1.isbn() == item2.isbn())<br />
				item2 += item1;<br />
			else<br />
				std::cout &lt;&lt; "Data must refer to same ISBN" &lt;&lt; std::endl;<br />
		}<br />
		std::cout &lt;&lt; "ISBN DATA" &lt;&lt; item2 &lt;&lt; std::endl;<br />
	}<br />
	else<br />
		std::cout &lt;&lt; "NO Data?!" &lt;&lt; std::endl;<br />
	return 0;<br />
}</pre>
</div>
</div>
<div>&nbsp;&nbsp;</div>
<div>
<p>练习 1.23：编写程序，读取多条销售记录，并统计每个ISBN（每本书）有几条销售记录。</p>
<p>解答：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include "Sales_item.h"<br />
int main()<br />
{<br />
	Sales_item item1, item2;<br />
	std::cout &lt;&lt; "Enter transactions:" &lt;&lt; std::endl;<br />
	if (std::cin &gt;&gt; item1)<br />
	{<br />
		int cnt = 1;<br />
		while (std::cin &gt;&gt; item2)<br />
		{<br />
			if (item1.isbn() == item2.isbn())<br />
			{<br />
				item2 += item1;<br />
				cnt++;<br />
			}<br />
			else<br />
			{<br />
				std::cout &lt;&lt; item1 &lt;&lt; std::endl;<br />
				item1  = item2;<br />
				cnt = 1;<br />
			}<br />
		}<br />
		std::cout &lt;&lt; item1.isbn() &lt;&lt; " had " &lt;&lt; cnt &lt;&lt; " records " &lt;&lt; std::endl;<br />
	}<br />
	else<br />
		std::cout &lt;&lt; "NO Data?!" &lt;&lt; std::endl;<br />
	return 0;<br />
}
</pre>
</div>
<p>练习1.24：输入表示多个ISBN 的多条销售记录来测试上一个程序，每个ISBN 的记录应该聚在一起。</p>
<p>解答：</p>
<p>运行上一个程序，输入多条测试即可。</p>
<p>练习 1.25：借助网站上的Sales_item.h 头文件，编译并运行本节给出的书店程序。</p>
<p>解答：</p>
<div>
<pre class="prettyprint linenums">#include &lt;iostream&gt;<br />
#include "Sales_item.h"

int main()<br />
{<br />
	Sales_item total;<br />
	if (std::cin &gt;&gt; total)<br />
	{<br />
		Sales_item trans;<br />
		while (std::cin &gt;&gt; trans)<br />
		{<br />
			if (total.isbn() == trans.isbn())<br />
				total += trans;<br />
			else<br />
			{<br />
				std::cout &lt;&lt; total &lt;&lt; std::endl;<br />
				total = trans;<br />
			}<br />
		}<br />
		std::cout &lt;&lt; total &lt;&lt; std::endl;<br />
	}<br />
	else<br />
	{<br />
		std::cout &lt;&lt; "NO Data?!" &lt;&lt; std::endl;<br />
		return -1;<br />
	}<br />
	return 0;<br />
}
</pre>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93wl0zq.html">安装ClouderaManager以及使用ClouderaManager安装分布式集群的若干细节</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8od3req.html">Frame创建窗体实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gw6kq.html">安装第三方Python模块，增加InfoPi的健壮性</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96kz7jq.html">&lbrack;转载&rsqb;JavaEE学习篇之&mdash;&mdash;JQuery技术详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8egy4m9.html">php创建多级目录的两种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/390z4jmq.html">CUDA编程学习（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1vyrx9.html">frequentism-and-bayesianism-chs-ii</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y37o5q.html">light开发框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1eewj8.html">HTML5 文件域&plus;FileReader 读取文件&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok647e9.html">NTOPNG，用来平时优化网站性能，用处大的</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp536jq.html">VJ16216&sol;RMQ&sol;线段树单点更新</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljdype9.html">Mysql之数据类型&lpar;胖胖老师&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y15y08.html">Android 基于MVC的MVVM模式开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp33139.html">WSDL文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o145opq.html">java中获取系统的当前时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xon49.html">12LaTeX学习系列之---LaTex的图片插入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ld3mq.html">dedecms调用日期格式化形式大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1rj35q.html">由n个元素组成的数组，n-2个数出现了偶数次，两个数出现了奇数次，且这两个数不相等，如何用O&lpar;1&rpar;的空间复杂度，找出这两个数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4gxoz9.html">使用Vue建立一个在线商店</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em1yge9.html">在Mac上快速Kill掉Tomcat</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e1gpde9.html">string标准库的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxzg48.html">MyEclipse 点击 部署 按钮 无效的解决办法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmw1xz9.html">MySQL添加中文字符集问题 --- java&period;sql&period;SQLException&colon; Incorrect string value</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdxdy78.html">Chrome下的语音控制框架MyVoix&period;js使用篇（四）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1w1e39.html">转：C语言申请内存时堆栈大小限制</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvl15oq.html">Android上传文件之FTP</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ov6j8.html">手机低端市场，联发科 vs 高通</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j03m70q.html">Android客户端实现七牛云存储文件上传</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn0ljpq.html">Javascript Promise 学习笔记</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gmwdxe9.html">JS&lpar;六&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
